VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDatabase"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private m_conDbase As ADODB.Connection
Private m_strPath As String
Private m_strSQL As String


Public Property Let Path(strPath As String)
    m_strPath = strPath
End Property
Public Property Get Path() As String
    Path = m_strPath
End Property

Public Property Let SQL(strSQL As String)
    m_strSQL = strSQL
End Property
Public Property Get SQL() As String
    SQL = m_strSQL
End Property

Public Function ConnectToDB() As Boolean

On Error GoTo ErrRoutine

    ConnectToDB = False

    Set m_conDbase = New ADODB.Connection

    m_conDbase.Open "PROVIDER=Microsoft.Jet.OLEDB.4.0;Data Source= " & Path
    
    ConnectToDB = True
    
Exit Function

ErrRoutine:

    ConnectToDB = False
    Err.Raise Err.Number, Err.Source, Err.Description

End Function

Public Function DisconnectFromDB() As Boolean

On Error GoTo ErrRoutine

    DisconnectFromDB = False
    
    m_conDbase.Close
    
Exit Function

ErrRoutine:

    DisconnectFromDB = False
    
End Function

Public Function ExecuteSQLBoolean() As Boolean

On Error GoTo ErrRoutine

    ExecuteSQLBoolean = False
        
    ConnectToDB
    
    m_conDbase.Execute SQL
    
    ExecuteSQLBoolean = True
        
    DisconnectFromDB
    
    Exit Function

ErrRoutine:

    ExecuteSQLBoolean = False

End Function

Public Function ExecuteSQLRecordset() As ADODB.Recordset

Dim rsRecordset As ADODB.Recordset

On Error GoTo ErrRoutine
        
    ConnectToDB
    
    Set rsRecordset = New ADODB.Recordset
    
    rsRecordset.Open SQL, m_conDbase, adOpenStatic, adLockOptimistic
    
    rsRecordset.Close
    
    Set ExecuteSQLRecordset = rsRecordset
    
'    DisconnectFromDBase
    
    Exit Function
    
ErrRoutine:

End Function
