VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWMIs"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"clsWMI"
Attribute VB_Ext_KEY = "Member0" ,"clsWMI"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'local variable to hold collection
Private m_Col As Collection

Public Enum eFindType
    eFindOne = 0
    eFindAll = 1
End Enum

Public Function Add(Optional sKey As String) As clsWMI
    'create a new object
    Dim objNewMember As clsWMI
    Set objNewMember = New clsWMI


    'set the properties passed into the method
    objNewMember.Index = Index
    objNewMember.WBEMClass = WBEMClass
    objNewMember.DispName = DispName
    objNewMember.Description = Description
    objNewMember.DispView = DispView
    If Len(sKey) = 0 Then
        m_Col.Add objNewMember
    Else
        m_Col.Add objNewMember, sKey
    End If


    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing


End Function

Public Property Get Item(vntIndexKey As Variant) As clsWMI
Attribute Item.VB_UserMemId = 0
    'used when referencing an element in the collection
    'vntIndexKey contains either the Index or Key to the collection,
    'this is why it is declared as a Variant
    'Syntax: Set foo = x.Item(xyz) or Set foo = x.Item(5)
  Set Item = m_Col(vntIndexKey)
End Property



Public Property Get Count() As Long
    'used when retrieving the number of elements in the
    'collection. Syntax: Debug.Print x.Count
    Count = m_Col.Count
End Property


Public Sub Remove(vntIndexKey As Variant)
    'used when removing an element from the collection
    'vntIndexKey contains either the Index or Key, which is why
    'it is declared as a Variant
    'Syntax: x.Remove(xyz)


    m_Col.Remove vntIndexKey
End Sub


Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    'this property allows you to enumerate
    'this collection with the For...Each syntax
    Set NewEnum = m_Col.[_NewEnum]
End Property


Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set m_Col = New Collection
End Sub


Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set m_Col = Nothing
End Sub


Public Function Find(eFind As eFindType, Optional intIndex As Integer)


Dim rsWMIs As ADODB.Recordset

Dim tempCol As Collection

Dim oWMI As clsWMI
Dim oDatabase As clsDatabase

    Set oDatabase = New clsDatabase
    oDatabase.Path = g_strDBPath
    
    Select Case eFind
        Case eFindOne:
            oDatabase.SQL = "SELECT * FROM tblWMI WHERE tblWMI_Index = " & intIndex
        Case eFindAll:
            oDatabase.SQL = "SELECT * FROM tblWMI ORDER BY tblWMI_DispName"
    End Select
    
    Set rsWMIs = New ADODB.Recordset
    Set rsWMIs = oDatabase.ExecuteSQLRecordset
    rsWMIs.Open
    
    With rsWMIs
    
        Do Until .EOF
        
            Set oWMI = New clsWMI
                        
            oWMI.Index = !tblWMI_Index
            oWMI.WBEMClass = !tblWMI_WBEMClass
            oWMI.DispName = !tblWMI_DispName
            oWMI.Description = !tblWMI_Description & ""
            oWMI.DispView = !tblWMI_DispView
            
            m_Col.Add oWMI, (CStr(oWMI.Index))
                       
            Set oWMI = Nothing
        
            .MoveNext
            
        Loop
        
    End With

End Function
