VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWMI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"clsWMIs"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'local variable(s) to hold property value(s)
Private m_intIndex As Integer 'local copy
Private m_strWBEMClass As String 'local copy
Private m_strDispName As String 'local copy
Private m_strDescription As String 'local copy
Private m_intDispView As Integer 'local copy
Private m_strComputer As String 'local copy
Private m_strNameSpace As String 'local copy
Private m_strUserName As String 'local copy
Private m_strPassword As String 'local copy

Public Property Let DispView(ByVal vData As Integer)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.DispView = 5
    m_intDispView = vData
End Property


Public Property Get DispView() As Integer
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.DispView
    DispView = m_intDispView
End Property



Public Property Let Description(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Description = 5
    m_strDescription = vData
End Property


Public Property Get Description() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Description
    Description = m_strDescription
End Property



Public Property Let DispName(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.DispName = 5
    m_strDispName = vData
End Property


Public Property Get DispName() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.DispName
    DispName = m_strDispName
End Property



Public Property Let WBEMClass(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.WBEMClass = 5
    m_strWBEMClass = vData
End Property


Public Property Get WBEMClass() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.WBEMClass
    WBEMClass = m_strWBEMClass
End Property



Public Property Let Index(ByVal vData As Integer)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Index = 5
    m_intIndex = vData
End Property


Public Property Get Index() As Integer
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Index
    Index = m_intIndex
End Property


Public Property Let Computer(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Index = 5
    m_strComputer = vData
End Property


Public Property Get Computer() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Index
    Computer = m_strComputer
End Property

Public Property Let UserName(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Index = 5
    m_strUserName = vData
End Property


Public Property Get UserName() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Index
    UserName = m_strUserName
End Property


Public Property Let NameSpace(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Index = 5
    m_strNameSpace = vData
End Property

Public Property Get NameSpace() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Index
    NameSpace = m_strNameSpace
End Property


Public Property Let Password(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Index = 5
    m_strPassword = vData
End Property

Public Property Get Password() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Index
    Password = m_strPassword
End Property


Public Function GetInfo() As String()

Dim wbemObjectset As SWbemObjectSet
Dim wbemObject As SWbemObject
Dim wbemProperty As SWbemProperty
Dim wbemService As SWbemServices
Dim wbemLocator As SWbemLocator

Dim strInfo() As String
Dim intX As Integer
Dim intY As Integer

    On Error Resume Next
    
    Set wbemLocator = CreateObject("WbemScripting.SWbemLocator")
    
    Set wbemService = wbemLocator.ConnectServer(Computer, NameSpace, UserName, Password)
    wbemService.Security_.ImpersonationLevel = 3
    
    Set wbemObjectset = wbemService.InstancesOf(WBEMClass)
    
    'get dimensions of the array.  needed because multidimensional arrays cannot use
    ' the redim preserve statement on the first dimension (intX)
    intX = 0
    intY = 0
    For Each wbemObject In wbemObjectset
        intX = wbemObjectset.Count
        intY = wbemObject.Properties_.Count
        Exit For
    Next
    
    ReDim strInfo(intX, intY)
    
    'add column and row headers
    'add column headers
    intX = 1    'space for the row headers
    intY = 0
    For Each wbemObject In wbemObjectset
        strInfo(intX, intY) = wbemObject.Name
        intX = intX + 1
    Next
            
    'add row headers
    intX = 0
    intY = 1    'space for the column headers
    For Each wbemObject In wbemObjectset
        For Each wbemProperty In wbemObject.Properties_
            strInfo(intX, intY) = wbemProperty.Name
            intY = intY + 1
        Next
        'so this is only done once
        Exit For
    Next
    
    'add information to the array
    intX = 1    'space for the row headers
    intY = 1    'space for the column headers
    For Each wbemObject In wbemObjectset
        For Each wbemProperty In wbemObject.Properties_
            strInfo(intX, intY) = wbemProperty.Value
            intY = intY + 1
        Next
        intX = intX + 1 'move to the next column
        intY = 1        'move back to the first row
    Next
   
    Set wbemObject = Nothing
    Set wbemObjectset = Nothing
    Set wbemProperty = Nothing
    Set wbemService = Nothing
    Set wbemLocator = Nothing
    
    GetInfo = strInfo
    
End Function
